<?php
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\Component\Jshopping\Site\Lib\JSFactory;

defined('_JEXEC') or die('Restricted access');

class plgJshoppingOrderDisplay_discount_percent extends CMSPlugin
{
    public function __construct(&$subject, $config = array()){
        parent::__construct($subject, $config);  
    }

    public function onBeforeCreateTemplateOrderMail(&$view){
        if ($view->order->order_discount > 0 && $view->order->coupon_id){        
            $coupon = JSFactory::getTable('coupon', 'jshop');
            $coupon->load($view->order->coupon_id);
            
            if (isset($coupon->coupon_id) && $coupon->coupon_id && $coupon->coupon_code != "" && $coupon->coupon_type == "0"){
                $view->_tmp_ext_discount_text .= ' ('.$coupon->coupon_value.' %)';
            }
        }
    }
    
    public function onBeforeCreatePdfOrder(&$order, &$vendorinfo, &$pdf){
        if (self::AP('show_in_pdf') == 1 && $order->order_discount > 0 && $order->coupon_id){        
            $coupon = JSFactory::getTable('coupon', 'jshop');
            $coupon->load($order->coupon_id);
            
            if (isset($coupon->coupon_id) && $coupon->coupon_id && $coupon->coupon_code != "" && $coupon->coupon_type == "0"){
                $order->_pdf_ext_discount_text .= ' ('.$coupon->coupon_value.' %)';
            }
        }
    }
    public function onBeforeDisplayOrderView(&$view){
        if ($view->order->order_discount > 0 && $view->order->coupon_id){        
            $coupon = JSFactory::getTable('coupon', 'jshop');
            $coupon->load($view->order->coupon_id);
            
            if (isset($coupon->coupon_id) && $coupon->coupon_id && $coupon->coupon_code != "" && $coupon->coupon_type == "0"){
                $view->_tmp_ext_discount_text .= ' ('.$coupon->coupon_value.' %)';
            }
        }
    }	
    public function onBeforeShowOrder(&$view){
        if ($view->order->order_discount > 0 && $view->order->coupon_id){        
            $coupon = JSFactory::getTable('coupon', 'jshop');
            $coupon->load($view->order->coupon_id);
            
            if (isset($coupon->coupon_id) && $coupon->coupon_id && $coupon->coupon_code != "" && $coupon->coupon_type == "0"){
                $view->_tmp_ext_discount_text .= ' ('.$coupon->coupon_value.' %)';
            }
        }
    }    
    
	public static function AP($param=null){
		$addon = JSFactory::getTable("addon", "jshop");
		$addon->loadAlias('display_discount_percent');
		$_AP = $addon->getParams();
		if($param !== null)
			return isset($_AP[$param]) ? $_AP[$param] : null;
		return $_AP;
	}
}