<?php
use Joomla\CMS\Plugin\CMSPlugin;
use Joomla\Component\Jshopping\Site\Lib\JSFactory;

defined('_JEXEC') or die('Restricted access');

class plgJshoppingCheckoutDisplay_discount_percent extends CMSPlugin
{
    public function __construct(&$subject, $config = array()){
        parent::__construct($subject, $config);  
    }

    public function onBeforeDisplayCartView(&$view){
        $this->_showDiscountCode($view);
    }
    
    public function onBeforeDisplayCheckoutCartView(&$view){
        $this->_showDiscountCode($view);
    }
    
    private function _showDiscountCode($view){
        if ($view->discount > 0){
            $cart = JSFactory::getModel('cart', 'jshop');
            $cart->load();
        
            $coupon = JSFactory::getTable('coupon', 'jshop');
            $coupon->load($cart->getCouponId());

            if (isset($coupon->coupon_id) && $coupon->coupon_id && $coupon->coupon_code != "" && $coupon->coupon_type == "0"){
                $view->_tmp_ext_discount_text .= ' ('.$coupon->coupon_value.' %)';
            }
        }
    }
}